/* vypoctete alespon 1 koren polynomu s koefcienty  1, 2, -3, 4, 5  */
/* Newtonova iteracni metoda                                        */

#include <stdio.h>

/* vypocet hodnoty obecneho polynomu */
double poly(double x, double koef[], int rad)
{
 int i;
 double y;

 if (rad<0) return 0;
 y=koef[rad];
 for (i=rad;i>0;i--)
  {
   y=y*x+koef[i-1];
  }
 return y;
}

/* vypocet hodnoty 1. derivace obecneho polynomu */
double dpoly(double x, double koef[], int rad)
{
 int i;
 double pom[20];

 if ((rad<1)||(rad>20)) return 0;

 for (i=1;i<=rad;i++) pom[i-1]=i*koef[i];
 return poly(x, pom, rad-1);
}


int main()
{
 /* vypocita koren polynomu */
 int i;
 double P[5]={1.0,2.0,-3.0,4.0,5.0};  // zadany polynom 4.radu
 double x1, x2, x3;

//   x2=x1-(F(x1)/dF(x1))     vzorecek iteracni metody pro vypocet i+1 odhadi z i-teho odhadu
 x2=0;  /* toto je odhad vysledku */
 do
 {
	 x1=x2;
	 x2=x1-(poly(x1,P,4)/dpoly(x1,P,4));
	 x3=x2-x1; if (x3<0) x3=-x3;
 } while (x3>1E-4);

 printf("\nKoren polynomu je %f\n", x2);

 getchar();
 return 0;

/* Toto jsou pro porovnani vsechny koreny vypocitane jinym zpusobem
   Real part      Imag part
  4.432384e-001 -5.170794e-001
  4.432384e-001  5.170794e-001
 -1.372256e+000  0.000000e+000
 -3.142206e-001  0.000000e+000

*/
}
